/*
 *   Copyright 2011 Institute of Communication and Computer Systems (ICCS) 
 *
 *   Licensed under the Apache License, Version 2.0 (the "License");
 *   you may not use this file except in compliance with the License.
 *   You may obtain a copy of the License at
 *
 *       http://www.apache.org/licenses/LICENSE-2.0
 *
 *   Unless required by applicable law or agreed to in writing, software
 *   distributed under the License is distributed on an "AS IS" BASIS,
 *   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *   See the License for the specific language governing permissions and
 *   limitations under the License.
 *
 */

#include "block_header.h"
#include "linked_lists/lifo_order.h"

void add_block_lifo_order(
#ifdef COUNT_HOPS
        heap_t *heap,
#endif /* COUNT_HOPS */
        void **block,
        void **starting_node) {
    if(*starting_node != NULL) {
#ifdef BLOCKS_IN_DLL
        set_previous(*starting_node, *block);
#endif /* BLOCKS_IN_DLL */
        set_next(*block, *starting_node);
    } else {
        set_next(*block, NULL);
    }
#ifdef BLOCKS_IN_DLL
    set_previous(*block, NULL);
#endif /* BLOCKS_IN_DLL */
    *starting_node = *block;
}

